/*
 * DownloadCallback.java
 * 17. November 2007, 23:16
 */

package de.siedler_maps.mapinstaller;

/**
 * Interface that has to be implemented when using the downloader.
 *
 * @author nevermind
 **/
public interface DownloadCallback
{
    /**
     * This is called when the next buffer was read.
     *
     * @param bytesRead Number of total bytes read.
     **/
    public void downloadUpdate(int bytesRead);
            
    /**
     * This is called when the download was finished.
     *
     * @param success True when the download was completed successful, false otherwise.
     **/
    public void downloadFinished(boolean success);
}
