/*
 * Language.java
 * 17. November 2007, 16:30
 */

package de.siedler_maps.mapinstaller;

import java.applet.Applet;
import java.util.Hashtable;

/**
 * Language management class.
 * @author nevermind
 **/
public class Language
{
    /** Language code of the user's language */
    private String languageCode;
    
    private Applet applet;
     
    /**
     * Constructor of Language.
     *
     * @param languageCode The code of the language.
     **/
    public Language(Applet applet)
    {
        this.applet = applet;
        this.languageCode = applet.getParameter("language");
    }
    
    /** Returns the language code. */
    public String getCode()
    {
        return languageCode;
    }
    
    /** Get the language value for the given key */
    public String get(String key, Object... args)
    {
        try
        {
            String value = applet.getParameter(key);

            if (value != null && args.length > 0)
            {
                value = String.format(value, args);
            }

            return value;
        }
        catch (NullPointerException ex)
        {
            return "";
        }
    }
}
